Qwt User's Guide: QwtAbstractScaleDraw Class Reference

# QwtAbstractScaleDraw Class Reference

A abstract base class for drawing scales. More...

`#include <qwt_abstract_scale_draw.h>`

Inheritance diagram for QwtAbstractScaleDraw:
[legend]

List of all members.

## Public Types
enum | ScaleComponent { Backbone = 1, Ticks = 2, Labels = 4 }
## Public Member Functions
| QwtAbstractScaleDraw ()
| QwtAbstractScaleDraw (const QwtAbstractScaleDraw &)
virtual | ~QwtAbstractScaleDraw ()
QwtAbstractScaleDraw & | operator= (const QwtAbstractScaleDraw &)
void | setScaleDiv (const QwtScaleDiv &s)
const QwtScaleDiv & | scaleDiv () const
void | setTransformation (QwtScaleTransformation *)
const QwtScaleMap & | map () const
void | enableComponent (ScaleComponent, bool enable=true)
bool | hasComponent (ScaleComponent) const
void | setTickLength (QwtScaleDiv::TickType, int length)
int | tickLength (QwtScaleDiv::TickType) const
int | majTickLength () const
void | setSpacing (int margin)
int | spacing () const
virtual void | draw (QPainter *, const QPalette &) const
virtual QwtText | label (double) const
virtual int | extent (const QPen &, const QFont &) const =0
void | setMinimumExtent (int)
int | minimumExtent () const
QwtScaleMap & | scaleMap ()
## Protected Member Functions
virtual void | drawTick (QPainter *painter, double value, int len) const =0
virtual void | drawBackbone (QPainter *painter) const =0
virtual void | drawLabel (QPainter *painter, double value) const =0
void | invalidateCache ()
const QwtText & | tickLabel (const QFont &, double value) const

## Detailed Description

A abstract base class for drawing scales.

QwtAbstractScaleDraw can be used to draw linear or logarithmic scales.

After a scale division has been specified as a QwtScaleDiv object using QwtAbstractScaleDraw::setScaleDiv(const QwtScaleDiv &s), the scale can be drawn with the QwtAbstractScaleDraw::draw() member.

## Member Enumeration Documentation

enum QwtAbstractScaleDraw::ScaleComponent

Components of a scale

- Backbone
- Ticks
- Labels

See also:
  enableComponent(), hasComponent

## Constructor & Destructor Documentation

QwtAbstractScaleDraw::QwtAbstractScaleDraw | ( |  | ) |

Constructor.

The range of the scale is initialized to [0, 100], The spacing (distance between ticks and labels) is set to 4, the tick lengths are set to 4,6 and 8 pixels

QwtAbstractScaleDraw::QwtAbstractScaleDraw | ( | const QwtAbstractScaleDraw & | other | ) |

Copy constructor.

QwtAbstractScaleDraw::~QwtAbstractScaleDraw | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

void QwtAbstractScaleDraw::draw | ( | QPainter * | painter,
|  | const QPalette & | palette |
| ) |  |  | const`[virtual]`

Draw the scale.

Parameters:

  | painter | The painter
  | palette | Palette, text color is used for the labels, foreground color for ticks and backbone

virtual void QwtAbstractScaleDraw::drawBackbone | ( | QPainter * | painter | ) | const`[protected, pure virtual]`

Draws the baseline of the scale

Parameters:

  | painter | Painter

See also:
  drawTick(), drawLabel()

Implemented in QwtRoundScaleDraw, and QwtScaleDraw.

virtual void QwtAbstractScaleDraw::drawLabel | ( | QPainter * | painter,
|  | double | value |
| ) |  |  | const`[protected, pure virtual]`

Draws the label for a major scale tick

Parameters:

  | painter | Painter
  | value | Value

See also:
  drawTick, drawBackbone

Implemented in QwtRoundScaleDraw, and QwtScaleDraw.

virtual void QwtAbstractScaleDraw::drawTick | ( | QPainter * | painter,
|  | double | value,
|  | int | len |
| ) |  |  | const`[protected, pure virtual]`

Draw a tick

Parameters:

  | painter | Painter
  | value | Value of the tick
  | len | Lenght of the tick

See also:
  drawBackbone(), drawLabel()

Implemented in QwtRoundScaleDraw, and QwtScaleDraw.

void QwtAbstractScaleDraw::enableComponent | ( | ScaleComponent | component,
|  | bool | enable = `true` |
| ) |  |  |

En/Disable a component of the scale

Parameters:

  | component | Scale component
  | enable | On/Off

See also:
  hasComponent()

virtual int QwtAbstractScaleDraw::extent | ( | const QPen & | ,
|  | const QFont & |  |
| ) |  |  | const`[pure virtual]`

Calculate the extent

The extent is the distcance from the baseline to the outermost pixel of the scale draw in opposite to its orientation. It is at least minimumExtent() pixels.

See also:
  setMinimumExtent(), minimumExtent()

Implemented in QwtRoundScaleDraw, and QwtScaleDraw.

bool QwtAbstractScaleDraw::hasComponent | ( | ScaleComponent | component | ) | const

Check if a component is enabled

See also:
  enableComponent()

void QwtAbstractScaleDraw::invalidateCache | ( |  | ) | `[protected]`

Invalidate the cache used by QwtAbstractScaleDraw::tickLabel

The cache is invalidated, when a new QwtScaleDiv is set. If the labels need to be changed. while the same QwtScaleDiv is set, QwtAbstractScaleDraw::invalidateCache needs to be called manually.

QwtText QwtAbstractScaleDraw::label | ( | double | value | ) | const`[virtual]`

Convert a value into its representing label.

The value is converted to a plain text using QLocale::system().toString(value). This method is often overloaded by applications to have individual labels.

Parameters:

  | value | Value

Returns:
  Label string.

Reimplemented in QwtDialScaleDraw.

int QwtAbstractScaleDraw::majTickLength | ( |  | ) | const

The same as QwtAbstractScaleDraw::tickLength(QwtScaleDiv::MajorTick).

const QwtScaleMap & QwtAbstractScaleDraw::map | ( |  | ) | const

Returns:
  Map how to translate between scale and pixel values

int QwtAbstractScaleDraw::minimumExtent | ( |  | ) | const

Get the minimum extent

See also:
  extent(), setMinimumExtent()

QwtAbstractScaleDraw & QwtAbstractScaleDraw::operator= | ( | const QwtAbstractScaleDraw & | other | ) |

Assignment operator.

const QwtScaleDiv & QwtAbstractScaleDraw::scaleDiv | ( |  | ) | const

Returns:
  scale division

QwtScaleMap & QwtAbstractScaleDraw::scaleMap | ( |  | ) |

Returns:
  Map how to translate between scale and pixel values

void QwtAbstractScaleDraw::setMinimumExtent | ( | int | minExtent | ) |

Set a minimum for the extent.

The extent is calculated from the coomponents of the scale draw. In situations, where the labels are changing and the layout depends on the extent (f.e scrolling a scale), setting an upper limit as minimum extent will avoid jumps of the layout.

Parameters:

  | minExtent | Minimum extent

See also:
  extent(), minimumExtent()

void QwtAbstractScaleDraw::setScaleDiv | ( | const QwtScaleDiv & | sd | ) |

Change the scale division

Parameters:

  | sd | New scale division

void QwtAbstractScaleDraw::setSpacing | ( | int | spacing | ) |

Set the spacing between tick and labels.

The spacing is the distance between ticks and labels. The default spacing is 4 pixels.

Parameters:

  | spacing | Spacing

See also:
  spacing()

void QwtAbstractScaleDraw::setTickLength | ( | QwtScaleDiv::TickType | tickType,
|  | int | length |
| ) |  |  |

Set the length of the ticks

Parameters:

  | tickType | Tick type
  | length | New length

Warning:
  the length is limited to [0..1000]

void QwtAbstractScaleDraw::setTransformation | ( | QwtScaleTransformation * | transformation | ) |

Change the transformation of the scale

Parameters:

  | transformation | New scale transformation

int QwtAbstractScaleDraw::spacing | ( |  | ) | const

Get the spacing.

The spacing is the distance between ticks and labels. The default spacing is 4 pixels.

See also:
  setSpacing()

const QwtText & QwtAbstractScaleDraw::tickLabel | ( | const QFont & | font,
|  | double | value |
| ) |  |  | const`[protected]`

Convert a value into its representing label and cache it.

The conversion between value and label is called very often in the layout and painting code. Unfortunately the calculation of the label sizes might be slow (really slow for rich text in Qt4), so it's necessary to cache the labels.

Parameters:

  | font | Font
  | value | Value

Returns:
  Tick label

int QwtAbstractScaleDraw::tickLength | ( | QwtScaleDiv::TickType | tickType | ) | const

Return the length of the ticks

See also:
  setTickLength(), majTickLength()